;Sprite and Mask Compression
;   by Sam Heald
;
; samsprite.exe compressed .bin files into .bin files
; ExtractMaskedSprite is the z80 decompression routine 
;
; ExtractMaskedSprite written by Kouri Rosenberg (kouri@ucdavis.edu)
;
; Input:  HL -> 1 set of sprites to extract
;         DE -> place to store extracted data (48 bytes required)
; Output: HL -> place of stored ext
; Registers modified: AF, DE, HL

ExtractMaskedSprite:
 push bc
 push hl
 ld bc,$0C3C
ExtractSprite:
 ldi
 ld a,(hl)
 and 11110000b
 ld (de),a
 inc de
 inc hl
 inc hl
 djnz ExtractSprite
 pop hl
 ld b,12
ExtractMask:
 inc hl
 ldi
 ldi
 djnz ExtractMask
 ex de,hl
 ld b,12
Shift:
 dec hl
 xor a
 rld
 dec hl
 rld

 djnz Shift
 pop bc
 ret